//------------------------------------------------------------------------------
//
//  [^[GR[_ eXg
//    荞ݔ `^O΍ǔ (ATmega88P)
//  Copyright (c) 2011 Let's Try It!
//
//------------------------------------------------------------------------------
#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>

ISR(PCINT0_vect)
{
	// `^Oh~
	_delay_ms(5);
	PCIFR = _BV(PCIF0);

	if (bit_is_clear(PINB, PB0))	// ÃXCb`I̎
	{
		// B̃XCb`I̎
		// v
		if (bit_is_clear(PINB, PB1))
		{
			// EɃrbgVtg
			PORTD >>= 1;
			if (PORTD == 0)
			{
				PORTD = 0x80;
			}
		}
		// B̃XCb`It̎
		// v
		else
		{
			// ɃrbgVtg
			PORTD <<= 1;
			if (PORTD == 0)
			{
				PORTD = 0x01;
			}
		}
	}
}

int main()
{
	DDRD = 0xff;	// |[gDo͂ɂ
	PORTD = 0x08;	// LED_
	DDRB = 0xfc;    // |[gB͂ɂ
	PORTB = 0x03;	// 01vAbv

	// 荞݂̐ݒ
	PCICR = _BV(PCIE0);			// PCIE0L(PCIE0 = PORTB)
	PCMSK0 = _BV(PCINT0);		// PCINT0L(PCINT0 = PB0)

	// 荞ݗL
	sei();

	// vOIȂ悤ɂ
	while (1)
	{
		PORTB |= _BV(PB2);
		_delay_ms(100);
		PORTB &= ~_BV(PB2);
		_delay_ms(100);
	}

	return 0;
}
